/*******************************************************************
* (c) Copyright 2000-12, Celstream Technologies Pvt Ltd.
* This program, or portions thereof, is protected as an
* unpublished work under the copyright laws of the India.
* TranslationDM.c
*
*  Created on: Jan 16, 2012
*      Author: sanjeevk
*/

#ifndef TRANSLATIONDM_H_
#define TRANSLATIONDM_H_
#include <stdio.h>
#include <libxml/parser.h>
#include <libxml/tree.h>
#include <string.h>


#define LIST_FILENAME 	"Translation_element_list.txt"
#define TRANSL_FILENAME "Translation_rules.txt"
#define DM_FILENAME 	"CWMP_DataModel.xml"
#define NM_FILENAME 	"Naming_Optimize.txt"
#define IN_FILE 		"PrintService.xsd"
#define ROOT 			"PrintServices"
#define STRL 			256
#define NU_OF_INCLUDES 	50
#define NU_OF_TR		50
#define NU_OF_OBJ 		2000
#define NU_OF_TYPE 		500
#define MIN_STRL 		50
#define MAX_ELEMENTS 	7000
#define NULL_CHARACTER 	0
#define DELIMITER ","

struct elementlist
{
	char parentname[STRL];/*For printing object name-concatenation occurs-temporary string*/
	char name[MAX_ELEMENTS][STRL];
	char typeprop[MAX_ELEMENTS][NU_OF_TYPE][MIN_STRL];
	char typevalue[MAX_ELEMENTS][NU_OF_TYPE][MIN_STRL];
	char minoccur[MAX_ELEMENTS][MIN_STRL];
	char maxoccur[MAX_ELEMENTS][MIN_STRL];
	int typecount;
	int count;
} st_El;

struct objectnodes
{
	 xmlNodePtr objectnode[NU_OF_OBJ];
	 char objectnodename[NU_OF_OBJ][STRL];
	 int count;
} obj;

struct Translation_rules
{
	char Translated[NU_OF_TR][STRL];
	char xsdtype[NU_OF_TR][STRL];
	char pwg_name[NU_OF_TR][STRL];
	char trans_name[NU_OF_TR][STRL];
	char edit[STRL];
	int algorithm;
} rule;

struct Import_include
{
	xmlNode *SR[NU_OF_INCLUDES];
	char 	files[NU_OF_INCLUDES][STRL];
	int 	included;
} Incs;


int 		Find_the_element_and_print	(xmlNode *root_element,char *elementname);
void 		Detect_the_type_and_print	(xmlNode *element_node);
void 		All_File_find_type_node		(char *typename,char *message);
xmlNode * 	File_find_type_node			(xmlNode *root_node,char *typepropname);
void 		Expand_type					(xmlNode *type_node);
void		Handle_SimpleType			(xmlNode *simpletypenode);
void 		Handle_simplecontent		(xmlNode *simplecontent_node);
void 		Handle_complexContent		(xmlNode *complexContent_node);
void 		Handle_cC_sequence			(xmlNode *sequence_node);
void 		Handle_choice				(xmlNode *choice_node);
void 		Handle_group				(xmlNode *group_ref_node);
void		Handle_attribute			(xmlNode *attr_node);
void 		Handle_anyattribute			(xmlNode *anyattr_node);
void 		Element_name_printer		(xmlNode *enode);
int 		Is_prop_val_exist			(xmlNode *nodewithprop,char *prop,char *val);
int 		Is_prop_exist				(xmlNode *nodewithprop,char *prop,char *val);
int 		compare						(char *s,char *d);
void 		Load_all_roots				(xmlNode *root_element);
int 		Is_file_already_included	(char *s);
char* 		XSD_types					(char *s);
char* 		Split_Copy					(char *pMain,char *pSplit,char *cDelimiter);
int 		Load_Translation_rule();
void 		Namespace_remove			(char *s);
void 		Trans_DM					();
void 		CWMP_find_obj_add_param		(char *fullpname,xmlNodePtr parameternode);
void 		CWMP_param_add_syntax		(int elementnumber,xmlNodePtr parameternode,int list);
char 		*Namingoptimize				(char *parentname,char *elementname);
void 		stPrint_type(char *name,char *value);
void 		stPrint_element(char *element_name,char *a,char *b);

#endif /* TRANSLATIONDM_H_ */
