/*******************************************************************
* (c) Copyright 2000-12, Celstream Technologies Pvt Ltd.
* This program, or portions thereof, is protected as an
* unpublished work under the copyright laws of the India.
* TranslationDM.c
*
*  Created on: Jan 20, 2012
*      Author: sanjeevk
*/
#include "TranslationDM.h"

/*adds type to the structure st_El*/
void stPrint_type(char *name,char *value)//depends on structure st_El
{
	strcpy(st_El.typeprop[st_El.count][st_El.typecount],name);
	strcpy(st_El.typevalue[st_El.count][st_El.typecount],value);
	st_El.typecount++;

}

/*adds element name to the structure*/
void stPrint_element(char *element_name,char *a,char *b)//depends on structure st_El
{

	st_El.typecount=0;
	snprintf(st_El.name[++st_El.count],STRL,"%s",element_name);
	if(a&&b)
	{
	strcpy(st_El.maxoccur[st_El.count],a);
	strcpy(st_El.minoccur[st_El.count],b);
	}
}


/*reads the translation file and fills the translation structure*/
int Load_Translation_rule()//depends on structure rule
{
	FILE *fff;
	int i=0;
	char read[STRL];

	fff=fopen(TRANSL_FILENAME,"r");
	if(!fff)
	{
		printf("\"%s\" not found\n",TRANSL_FILENAME);
		return 0;
	}

	while(!feof(fff))
	{
		memset(read,NULL_CHARACTER,sizeof(read));
		fscanf(fff,"%s",read);
		if(!strstr(read,"-->"))
		{
			printf("Invalid translation rules\n");
			return 0;
		}
		strcpy(rule.Translated[i],&read[strstr(read,"-->")-read+3]);
		read[strstr(read,"-->")-read]=0;
		strcpy(rule.xsdtype[i],read);
		i++;
	}

	fclose(fff);

	i=0;
	fff=fopen(NM_FILENAME,"r");
	if(!fff)
	{
		printf("\"%s\" not found\n",NM_FILENAME);
		rule.algorithm=1;
		return 1;
	}

	while(!feof(fff))
	{
		memset(read,NULL_CHARACTER,sizeof(read));
		fscanf(fff,"%s",read);
		if(!strstr(read,"-->"))
		{
			printf("Invalid naming naming rules\n");
			rule.algorithm=1;
			return 1;
		}
		strcpy(rule.trans_name[i],&read[strstr(read,"-->")-read+3]);
		read[strstr(read,"-->")-read]=0;
		strcpy(rule.pwg_name[i],read);
		i++;
	}

	fclose(fff);
	printf("\nTranslation rules loaded");
	return 1;
}

/* splits the given string at place of delimiter and returns the pointer to the next string*/
char* Split_Copy(char *pMain,char *pSplit,char* cDelimiter)
{
	int iLength;

	iLength=strstr(pMain,cDelimiter)-pMain;
	pMain[iLength]=NULL_CHARACTER;
	if(pSplit)
	{
		strcpy(pSplit,pMain);
	}
	pMain+=iLength+1;
	return pMain;
}

/*string compare*/
int compare(char *s,char *d)
{
	if(!strcmp(s,d))
	{
		return 1;
	}
	else
	{
		return 0;
	}
}

/*checks if the string is a XSD data type and returns the pointer to the type translation*/
char* XSD_types(char *s)//depends on structure rule
{
	int i;

	for(i=0;i<NU_OF_TR;i++)
	{
		if(compare(s,rule.xsdtype[i]))
		{
		return (rule.Translated[i]);
		}
	}
	return NULL;
}


/*checks if the property with the specified vale is present in the node*/
int Is_prop_val_exist(xmlNode *nodewithprop,char *prop,char *val)
{
	struct _xmlAttr *child_node_prop=NULL;

	for(child_node_prop=nodewithprop->properties;child_node_prop;child_node_prop=child_node_prop->next)
	{
		if(compare(child_node_prop->name,prop)&&compare(child_node_prop->children->content,val))
		{
			return 1;
		}
	}
	return 0;
}

/*checks if the pr0perty is present in the node and returns the value*/
int Is_prop_exist(xmlNode *nodewithprop,char *prop,char *val)
{
	struct _xmlAttr *child_node_prop=NULL;

	for(child_node_prop=nodewithprop->properties;child_node_prop;child_node_prop=child_node_prop->next)
	{
		if(compare(child_node_prop->name,prop))
		{
			strcpy(val,child_node_prop->children->content);
			return 1;
		}
	}
	return 0;
}


/* removes the name: infront of the type and elementname*/
void Namespace_remove(char *s)
{
	if(strstr(s,":"))
		{
			int ff=0;
			for(ff=0;ff<strlen(s);ff++)
			{
				if(s[ff]==':')
				{
					strcpy(s,&s[ff+1]);
				}
			}
		}
	/*REMOVES namespace:*/
return;
}


/* replace the name of the object*/
char *Namingoptimize(char *parentname,char *elementname)//depends on structure rule
{
	int i;
if(rule.algorithm)
{
	char all_elements[100][STRL],objectname[STRL]={0},syllables[200][STRL];
	char *string;
	int elementcount=0,syllablecount=0;;

	memset(all_elements,NULL_CHARACTER,sizeof(all_elements));
	memset(objectname,NULL_CHARACTER,sizeof(objectname));
	memset(syllables,NULL_CHARACTER,sizeof(syllables));

	strcpy(objectname,parentname);
	strcat(objectname,".");/* For splitting based on delimiter-used by Split_Copy()*/
	string=objectname;
	for(i=0;string[0]!=NULL_CHARACTER;)
	{
		string=Split_Copy(string,all_elements[i],".");
		if(!strstr(all_elements[i],"{"))
		{
			i++;
		}
	}
	elementcount=i;

	int j=-1,internal=0;
	for(i=0;i<strlen(elementname);i++)
	{
		if(elementname[i]>='A' && elementname[i]<='Z')
		{
			j++;
			internal=0;
		}
		syllables[j][internal++]=elementname[i];
	}

	syllablecount=j+1;

	for(j=0;j<syllablecount-1;j++)
	{
		for(i=elementcount-1;i>=0;i--)
		{
			if(strstr(all_elements[i],syllables[j]))
			{
				syllables[j][0]=0;
			}
		}
	}

	memset(rule.edit,NULL_CHARACTER,sizeof(rule.edit));
	for(j=0;j<syllablecount;j++)
		{
		strcat(rule.edit,syllables[j]);
		}
	return rule.edit;
}

	for(i=0;i<NU_OF_TR;i++)
	{
		if(compare(elementname,rule.pwg_name[i]))
		{
			return rule.trans_name[i];
		}
	}

	return elementname;

}



/* compares the string with file names already included*/
int Is_file_already_included(char *s)//depends on structure Incs
{
	int i;

	if(!s)
	{
		printf("\n Invalid parameters");
		return 2;
	}

	for(i=0;i<NU_OF_INCLUDES;i++)
	{
		if(compare(s,Incs.files[i]))
		{
			return 1;
		}
	}
	return 0;
}

/*parse the schema children to find and load all the included files*/
void Load_all_roots(xmlNode *root_element)//depends on structure Incs
{
	xmlDoc *doc = NULL;
	xmlNode *sch_node = NULL;
	char filename[STRL];
	if(root_element==NULL)
	{
		printf("\nInvalid root element");
		return;
	}

	for (sch_node = root_element->children; sch_node; sch_node = sch_node->next)
	{
		if(compare(sch_node->name,"include")||compare(sch_node->name,"import"))
		{
			if(Is_prop_exist(sch_node,"schemaLocation",filename))
			{
				if(Is_file_already_included(filename)==0)
				{
					strcpy(Incs.files[Incs.included],filename);
					doc = xmlReadFile(filename, NULL, 0);
					printf("\n %d. %s",Incs.included,filename);
					if (doc == NULL)
					{
						printf("\nerror: could not parse file %s",filename);
						//getch();
						return;
					}
					Incs.SR[Incs.included++] = xmlDocGetRootElement(doc);
					Load_all_roots(Incs.SR[Incs.included-1]);
				}
			}
		}
	}
	return;
}
